"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformLess = void 0;
const less_1 = __importDefault(require("less"));
const less_plugin_module_resolver_1 = require("less-plugin-module-resolver");
const promises_1 = require("fs/promises");
const transformLess = (filePath, options) => __awaiter(void 0, void 0, void 0, function* () {
    const code = yield (0, promises_1.readFile)(filePath, 'utf-8');
    const result = yield less_1.default.render(code, {
        filename: filePath,
        syncImport: true,
        /**
         * Legacy compatible
         */
        plugins: [
            new less_plugin_module_resolver_1.LessPluginModuleResolver({
                alias: Object.assign({ '~': '' }, options.alias),
            }),
        ],
        sourceMap: options.sourcemap
            ? {
                sourceMapFileInline: false,
                outputSourceFiles: true,
            }
            : undefined,
    });
    let { css, map, imports } = result;
    imports = imports.filter((item) => item !== filePath);
    return { css, map, imports };
});
exports.transformLess = transformLess;
